#ifndef COMMON_LIST_H
#define COMMON_LIST_H 1

#include <metamail/common.h>

BEGIN_C_DECLS

typedef int (*dlist_comp) (void*, void*);

typedef struct dlistentry {
  struct dlistentry *next;
  struct dlistentry *prev;
  void *data;
} DListEntry;

typedef struct dlist {
  DListEntry *head;
  DListEntry *tail;
} DList;

extern const DList DListNULL;

extern DListEntry *dlist_new         (void* data);
extern void        dlist_cat         (DList* list1, DList* list2);
extern DListEntry *dlist_insert_new  (DList* list, void* data,
				      DListEntry* pos);
extern DListEntry *dlist_insert      (DList* list, DListEntry* new,
				      DListEntry* pos);
extern DListEntry *dlist_insert_sort (DList* list, DListEntry* new, 
				      dlist_comp cmp);
extern DListEntry *dlist_append      (DList* list, DListEntry* new);
extern DListEntry *dlist_head        (DList* list);
extern DListEntry *dlist_tail        (DList* list);
extern size_t      dlist_length      (DList* list);
extern DListEntry *dlist_remove      (DList* list, DListEntry* entry);

extern DListEntry *dlist_search      (DList* list, void* data, dlist_comp cmp);

extern int dlist_strcmp              (void* data1, void* data2);

END_C_DECLS

#endif /* !COMMON_LIST_H */
