#if HAVE_CONFIG_H
#  include <config.h>
#endif

#include "common.h"
#include "error.h"

void *
xmalloc (size_t num)
{
  void *new = malloc (num);
  if (!new)
    metamail_fatal ("Memory exhausted");
  return new;
}

void *
xrealloc (void *p, size_t num)
{
  void *new;
  
  if (!p)
    return xmalloc (num);
  
  new = realloc (p, num);
  if (!new)
    metamail_fatal ("Memory exhausted");
  
  return new;
}

void *
xcalloc (size_t num, size_t size)
{
  void *new = xmalloc (num * size); // is implemented by malloc, cause calloc
  bzero (new, num * size);          // is not available in some older C libs
  return new;
}
