#ifndef METAMAIL_H
#define METAMAIL_H

#include <metamail/common.h>
#include <metamail/patchlevel.h>

BEGIN_C_DECLS

#define CATCOMMAND  "cat"
#define CATTEMPLATE "cat %s"
#define METAMAIL    "metamail"

#define WRITE_BINARY	"w"

#define CMDSIZE 1200            /* Maximum size of command to execute */

#define LINE_BUF_SIZE       2000

//static char *nomem = "Out of memory!";
extern char *mmversion;
extern char *NoAskDefault;
extern char *QuietDefault;
extern char *tmproot;

#define ENCODING_NONE 0
#define ENCODING_BASE64 1
#define ENCODING_QUOTEDPRINTABLE 2
#define ENCODING_8BIT 3
#define ENCODING_UUENCODE -1	/* non-standard */

// for mailto.c (cutted and pasted ere)
#define MINCHUNKSIZE 20000      /* Better be enough to hold the headers, or we
				   die! */
#define MAX_LINELENGTH  2000

struct NoAskItem {
    char *type;
    struct NoAskItem *next;
};

extern char             *mailheaders;
extern char             *MailerName;
extern char             *ContentType;
extern int               Quiet;
extern struct NoAskItem *FirstNoAskItem;
extern struct NoAskItem *FirstQuietItem;
extern int               TransparentMode;
extern int               RunAsRootOK;
extern int               DoDebug;
extern int               YankMode;
extern int               MightAskBeforeExecuting;
extern int               DefinitelyNotTty;
extern int               MustNotBeTty;
extern int               MaybePageOutput;

END_C_DECLS

#endif /* METAMAIL_H */




