#include <metamail/common.h>
#include <metamail/dlist.h> /* double linked list management */

#include "tmpfile.h"
#include "metamail.h"

DList TmpNameList = { NULL, NULL };

void
MkTmpFileName(name)
     char *name;
{
  int   tmpfd   = 0;

  if (DoDebug) 
    fprintf(stderr, "MkTmpFileName:\n");

  if (!name) {
    if (DoDebug)
      fprintf(stderr, "name is null\nMkTmpFileName END\n");
    return;
  }
  
  strcpy(name, tmproot);
  strcat(name, "/MXXXXXX");
 
  if ((tmpfd = mkstemp(name)) > 0) {
    if (close(tmpfd) == -1) {
      metamail_warning( "couldn't close tmpfile: ", xstrerror( errno ) );
      name[0] = 0;
      return;
    }
    if (DoDebug)
      fprintf(stderr, "name = \"%s\"\n", name);
    AddTmpFileName( name );
    if (DoDebug)
      fprintf( stderr, "MkTmpFileName END\n", name);
  } else {
    metamail_warning( "couldn't optain tmpfile: ", xstrerror( errno ) );
    return;
  }
}

void
AddTmpFileName(name)
     char *name;
{
  char *tmpname = NULL;
  if ( name ) {
    tmpname = XMALLOC( char, strlen(name) + 1 );
  
    strcpy( tmpname, name );
    dlist_insertnew( &TmpNameList, (void*) tmpname, TmpNameList.tail );
    if (DoDebug)
      fprintf( stderr, "AddTmpFileName: %s\n", name );
  }
}

void
DelTmpFileName(name)
     char *name;
{
  DListEntry *help = NULL;
  
  if ( (help = dlist_remove( &TmpNameList, dlist_search( &TmpNameList, name, 
							 dlist_strcmp ) ) ) ) {
    XFREE( help->data );
    XFREE( help );
  } else
    fprintf(stderr, "tried to remove non tmplist file %s\n", name);
}

void
RmTmpFileName(name)
     char *name;
{
  DListEntry* help = NULL;
  
  if (DoDebug) 
    fprintf( stderr, "RmTmpFileName:\n" );

  if( (help = dlist_remove( &TmpNameList, 
			    dlist_search( &TmpNameList, name, 
					  dlist_strcmp ) ) ) ) {
    if (DoDebug) fprintf( stderr, "filename: %s\n", name );
    if (!access( name, R_OK ) ) { 
      if(unlink( name ) == -1)
	metamail_error( stderr, "error unlinking: ", xstrerror( errno ) );
    }
    XFREE( help->data );
    XFREE( help );
  }
}

void
CleanupTmpFiles( void )
{
  DListEntry* help = NULL;
  
  if (DoDebug) 
    fprintf( stderr, "CleanupTmpFiles:\n" );

  while ( TmpNameList.head ) {
    if (DoDebug) fprintf(stderr, "tmpfile: %s  %X\n", TmpNameList.head->data,
			 TmpNameList.head->next);
    if (!access( (char*) TmpNameList.head->data, R_OK )) {
      if (DoDebug) fprintf( stderr, "access file yes\n" );
      if (unlink( (char*) TmpNameList.head->data ) < 0) {
	if (DoDebug) 
	  metamail_error( stderr, "error unlinking: ", 
			  (char*) TmpNameList.head->data );
      }
    }
    
    help = dlist_remove( &TmpNameList, TmpNameList.head );
    if (DoDebug) fprintf( stderr, "%X\n", help );
    XFREE( help->data );
    XFREE( help );
  }
}
